#include "stdafx.h"
#include "NeMessenger.h"
#include "FavoriteListDlg.h"


IMPLEMENT_DYNAMIC(CFavoriteListDlg, CBaseDlgStyleOne)

CFavoriteListDlg::CFavoriteListDlg(CWnd* pParent)
	: CBaseDlgStyleOne(CFavoriteListDlg::IDD, pParent)
{
	g_bFavoriteListDlgOpened = true;
	m_nSelectedItem = -1;
	m_strSelectGroupName = _T("");

	m_mapFavoriteList.clear();
}

CFavoriteListDlg::~CFavoriteListDlg()
{
	g_bFavoriteListDlgOpened = false;
	m_penBorder.DeleteObject();
	m_ImageList.DeleteImageList();
}

void CFavoriteListDlg::DoDataExchange(CDataExchange* pDX)
{
	CBaseDlgStyleOne::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_FAVORITE_LIST, m_lcFavorite);
}


BEGIN_MESSAGE_MAP(CFavoriteListDlg, CBaseDlgStyleOne)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_FAVORITE_LIST, &CFavoriteListDlg::OnLvnItemchangedFavoriteList)
	ON_WM_PAINT()
END_MESSAGE_MAP()

BOOL CFavoriteListDlg::OnInitDialog()
{
	CBaseDlgStyleOne::OnInitDialog();

	ModifyStyle(0, WS_CLIPCHILDREN);
	SetWindowText(LoadStringFromResource(IDS_STRING262));	// ã ߰

	__ResourceLoad(TRUE);

	if (m_ImageList.Create(11, 11, ILC_COLOR32 | ILC_COLOR | ILC_MASK, 2, 2))
	{
		COLORREF crMask = RGB(0, 0, 0);

		CBitmap bmRadio[2];

		LoadBitmapFromPath(bmRadio[0], GetAppImgFile(_T("13_Radio_Button_Unchecked.bmp")));
		LoadBitmapFromPath(bmRadio[1], GetAppImgFile(_T("13_Radio_Button_Checked.bmp")));

		m_ImageList.Add(&bmRadio[0], crMask);
		m_ImageList.Add(&bmRadio[1], crMask);

		bmRadio[0].DeleteObject();
		bmRadio[1].DeleteObject();
	}

	// Ʈ ÷  
	m_arListHeaderTitle.Add(_T(""));								//  
	m_arListHeaderTitle.Add(LoadStringFromResource(IDS_STRING278));	// ̸

	int colWidthListFavorite[] = {
		24,		//0
		210,	//1
		-1
	};		

	m_lcFavorite.SetImageList(&m_ImageList, LVSIL_SMALL);
	InitList(m_lcFavorite, m_arListHeaderTitle);
	ResizeListColumn(m_lcFavorite, colWidthListFavorite);

	m_penBorder.CreatePen(PS_SOLID, 1, RGB(220,220,220));

	MoveWindow(0, 0, 300, 250);
	ReSizeCtrl();
	CenterWindow(GetParent());

	return TRUE;  // return TRUE unless you set the focus to a control
}

void CFavoriteListDlg::__ResourceLoad(BOOL bInit)
{
	if (bInit == FALSE)
		SendMessage(WM_SIZE, NULL, NULL);
}

void CFavoriteListDlg::InitList(CNListCtrl &list, CStringArray &strHeaderTitle)
{
	LV_COLUMN lvcolumn;
	memset(&lvcolumn, 0, sizeof(lvcolumn));
	lvcolumn.mask = LVCF_FMT | LVCF_SUBITEM | LVCF_TEXT;

	for (int i = 0; i < strHeaderTitle.GetCount(); i++)
	{
		lvcolumn.fmt = LVCFMT_LEFT;
		lvcolumn.pszText = (LPTSTR)(LPCTSTR)strHeaderTitle.GetAt(i);
		lvcolumn.iSubItem = i;
		list.InsertColumn(i, &lvcolumn);
	}

	list.SetExtendedStyle(LVS_EX_DOUBLEBUFFER | LVS_EX_FULLROWSELECT);
	list.EnableToolTips(FALSE);
	// Ʈ   
	list.SetRowHeight(20);
	// Ʈ Ʈ 
	list.SetTextFont(&g_ftDefault8PT);
	list.SetSelectedTextColor(COLOR_SELECTED_TEXT, COLOR_NORMAL_BK);	// û ǥ ʴ´.

	// ã Ʈ 
	int nIndex = 0;
	BOOL bDefaultGroupSelected = FALSE;	// ⺻ ׷ õǾ?

	for (FAVORITE_LIST::iterator itor = m_mapFavoriteList.begin(); itor != m_mapFavoriteList.end(); itor++)
	{
		CString strFavName = *itor;
		
		m_lcFavorite.InsertItem(nIndex, _T(""));
		m_lcFavorite.SetItemText(nIndex, 1, strFavName);

		if (m_strSelectGroupName.CompareNoCase(strFavName) == 0)
		{
			m_lcFavorite.SetItemImage(nIndex, 0, 1);
			m_nSelectedItem = nIndex;
			bDefaultGroupSelected = TRUE;
		}
		else
		{
			m_lcFavorite.SetItemImage(nIndex, 0, 0);
			m_strSelectGroupName = m_lcFavorite.GetItemText(0, 1);
		}

		nIndex++;
	}

	if (!bDefaultGroupSelected && m_lcFavorite.GetItemCount() > 0)
	{
		m_lcFavorite.SetItemImage(0, 0, 1);
		m_nSelectedItem = 0;
	}
}

void CFavoriteListDlg::ResizeListColumn(CNListCtrl &list, const int *arrWidth)
{
	for (int i = 0; arrWidth[i] != -1; i++)
	{
		list.SetColumnWidth(i, arrWidth[i]);
	}

	list.RedrawWindow();
}

void CFavoriteListDlg::ReSizeCtrl(void)
{
	CRect rcClient(0, 0, 0, 0);
	GetClientRect(&rcClient);

	// List
	if (m_lcFavorite.GetSafeHwnd() != NULL)
		m_lcFavorite.MoveWindow(10, 10, rcClient.right - 20, rcClient.bottom - 55, TRUE);

	// OK Button
	CButton *pBtnOK = (CButton *)GetDlgItem(IDOK);

	if (pBtnOK->GetSafeHwnd() != NULL)
		pBtnOK->MoveWindow(rcClient.CenterPoint().x - FAVORITE_LIST_DLG_BTN_WIDTH - 4, rcClient.bottom - 36, FAVORITE_LIST_DLG_BTN_WIDTH, FAVORITE_LIST_DLG_BTN_HEIGHT, TRUE);

	// Cancel Button
	CButton *pBtnCancel = (CButton *)GetDlgItem(IDCANCEL);

	if (pBtnCancel->GetSafeHwnd() != NULL)
		pBtnCancel->MoveWindow(rcClient.CenterPoint().x +4, rcClient.bottom - 36, FAVORITE_LIST_DLG_BTN_WIDTH, FAVORITE_LIST_DLG_BTN_HEIGHT, TRUE);
}

void CFavoriteListDlg::InsertFavoriteItem(CString strFavoriteName)
{
	m_mapFavoriteList.push_back(strFavoriteName);
}

int CFavoriteListDlg::GetSelectedItemIndex()
{
	return m_nSelectedItem;
}

void CFavoriteListDlg::OnLvnItemchangedFavoriteList(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);
	
	if (!(pNMLV->uChanged == LVIF_STATE && pNMLV->uNewState == (LVIS_SELECTED | LVIS_FOCUSED)))
        return;

    int nSelectItem = pNMLV->iItem;

    if (-1 == nSelectItem)
        return;

	for (int i = 0; i < m_lcFavorite.GetItemCount(); i++)
	{
		if (i == nSelectItem)
			m_lcFavorite.SetItemImage(i, 0, 1);
		else if (m_lcFavorite.GetItemImage(i, 0) != 0)
			m_lcFavorite.SetItemImage(i, 0, 0);
	}

	m_nSelectedItem = nSelectItem;
	m_strSelectGroupName = m_lcFavorite.GetItemText(nSelectItem, 1);

	*pResult = 0;
}

void CFavoriteListDlg::SetDefaultSelectGroup(CString strGroupName)
{
	m_strSelectGroupName = strGroupName;
}

CString CFavoriteListDlg::GetSelectedGroupName()
{
	return m_strSelectGroupName;
}

void CFavoriteListDlg::OnPaint()
{
	CPaintDC dc(this); // device context for painting

	CRect rcClient(0, 0, 0, 0);
	GetClientRect(&rcClient);

	NMMemDC memDC;
	memDC.CreateCompatibleDC(&dc, &rcClient);

	// 
	memDC.FillSolidRect(0, 0, rcClient.Width(), rcClient.Height(), RGB(255, 255, 255));

	// ֻ μ
	CPen *pOldPen = memDC.SelectObject(&m_penBorder);
	memDC.MoveTo(0, 0);
	memDC.LineTo(rcClient.right, 0);

	// memDC -> PaintDC
	dc.BitBlt(0, 0, rcClient.Width(), rcClient.Height(), &memDC, 0, 0, SRCCOPY);	

	memDC.SelectObject(pOldPen);
}

void CFavoriteListDlg::OnOK()
{
	// õ ȭ ׷ ȿ Ȯ
	const IGTBuddyGroup *pGroup = g_pMessengerActor->GetBuddyGroupInfo(m_strSelectGroupName);

	if (!pGroup)
	{
		NMessageBox(this, LoadStringFromResource(IDS_STRING326));
		return;
	}

	CBaseDlgStyleOne::OnOK();
}
